--[[SUBmission 1.0
made by Xul8t0r]]
boatTypes = 3
boatInfo = {0,0,0,0,0,0}
missileInfo = {0,0,0}
score = {0,0,0}
boatNumber = 0
missileNumber = 0
gameOver = 0
pause = 0
boatArray = {{Image.load("1.png"),Image.load("2.png"),Image.load("3.png")},{Image.load("1rev.png"),Image.load("2rev.png"),Image.load("3rev.png")}}
missile = Image.load("missile.png")
arrow = Image.load("arrow.png")
sun = Image.load("sun.png")
myColor = Color.new(0, 255, 0)
ending = Sound.load("end.wav")
firing = Sound.load("fire.wav")
hitting = Sound.load("hit.wav")

function Form1_Load()
 math.randomseed(os.time())
 file = io.open("hi", "r")
 if file then
  score[2] = file:read("*n")
  if score[2] >= 1000000 then
   score[2]=0
  end
  file:close()
 else
  score[2]=0
 end
 ResetGame()
 gameOver = 2
end

function Form1_Click()
 if missileInfo[3] == 0 and gameOver == 0 then
  firing:play()
  missileInfo[3] = 1
  myColor = Color.new(255, 0, 0)
  missileInfo[1] = x0
  missileNumber = missileNumber-1
 end
 if gameOver > 0 then
  ResetGame()
 end
end

function Form1_Paint()
 screen:clear()
 if score[1] > score[2] and score[1] < 1000000 then
  score[2] = score[1]
  score[3] = 1
 end
 screen:fillRect(0, 0, 480, 56, Color.new(0, 255, 255))
 screen:blit(360, 20, sun)
 screen:fillRect(0, 56, 480, 196, Color.new(0, 0, 255))
 screen:blit(missileInfo[1], missileInfo[2], missile)
 screen:blit(boatInfo[2],boatInfo[3],boatArray[boatInfo[5]][boatInfo[1]])
 screen:fillRect(0, 252, 480, 20, Color.new(0, 0, 0))
 screen:fillRect(4, 256, 12, 12, myColor)
 screen:print(30, 259, string.format("Missiles:%02d",missileNumber), Color.new(255, 255, 255))
 screen:print(130, 259, string.format("Boats:%02d",boatNumber), Color.new(255, 255, 255))
 screen:print(270, 259, string.format("Score:%06d",score[1]), Color.new(255, 255, 255))
 screen:print(380, 259, string.format("High:%06d",score[2]), Color.new(255, 255, 255))
 if gameOver == 1 then
  screen:print(176, 120, "GAME OVER", Color.new(255, 0, 0))
  screen:print(176, 140, "Press X to try again", Color.new(255, 0, 0))
  if score[3] == 1 then
   screen:print(176, 160, "NEW HIGH-SCORE!", Color.new(255, 0, 0))
  end
 elseif gameOver == 2 then
  screen:print(176, 120, "SUBmission 1.0", Color.new(255, 0, 0))
  screen:print(176, 140, "Made by Xul8t0r", Color.new(255, 0, 0))
  screen:print(176, 160, "Press X to begin", Color.new(255, 0, 0))
 end
 screen:blit(x0, y0, arrow)
 screen.waitVblankStart()
 screen.flip()
end

function Form1_Disposed()
 if score[3] == 1 then
 	file = io.open("hi", "w")
 	if file then
   file:write(score[2])
   file:close()
 	end
 end
end

function Timer1_Tick()
 boatInfo[2] = boatInfo[2] + (boatInfo[4]*boatInfo[6])
 Form1_Paint()
 if (boatInfo[2] > 480 and boatInfo[5] == 1) or (boatInfo[2] < -boatArray[boatInfo[5]][boatInfo[1]]:width() and boatInfo[5] == 2) then
  ResetBoat()
 end
end

function Timer2_Tick()
 if missileInfo[3] == 1 then
  missileInfo[2] = missileInfo[2] - 3
 end
 if missileInfo[2] <= 56 then
 	ResetMissile()
 end
 Form1_Paint()
 if boatInfo[3] + boatArray[boatInfo[5]][boatInfo[1]]:height() - 3 >= missileInfo[2] and boatInfo[3] + boatArray[boatInfo[5]][boatInfo[1]]:height() <= missileInfo[2] + missile:height() and missileInfo[1] >= boatInfo[2] and missileInfo[1] <= boatInfo[2] + boatArray[boatInfo[5]][boatInfo[1]]:width() then
  hitting:play()
  Form1_Paint()
  score[1] = score[1] + (boatInfo[1] * 100)
  ResetBoat()
  ResetMissile()
 end
end

function EndGame()
 ending:play()
 gameOver = 1
 i=0
 Form1_Paint()
 Form1_Disposed()
end

function ResetGame()
 score[1] = 0
 score[3] = 0
 gameOver = 0
 x0 = 240
 y0 = 200
 missileNumber = 20
 boatNumber = 31
 ResetBoat()
 ResetMissile()
 Form1_Paint()
end

function ResetBoat()
 boatInfo[5] = MyRandom(1,2)
 boatInfo[1] = MyRandom(1,3)
 if boatInfo[5] == 1 then
  boatInfo[2] = -1 * boatArray[boatInfo[5]][boatInfo[1]]:width()
  boatInfo[6] = 1
 else
  boatInfo[2] = 480
  boatInfo[6] = -1
 end
 boatInfo[3] = MyRandom(60,250-boatArray[boatInfo[5]][boatInfo[1]]:height())
 boatInfo[4] = MyRandom(math.ceil(boatArray[boatInfo[5]][boatInfo[1]]:width() * 0.03),math.ceil(boatArray[boatInfo[5]][boatInfo[1]]:width() * 0.05))
 boatNumber = boatNumber - 1
 if boatNumber == 0 then
  ResetMissile()
  EndGame()
 end
end

function ResetMissile()
 missileInfo[2] = 272 - missile:height()
 missileInfo[3] = 0
 myColor = Color.new(0, 255, 0)
 if missileNumber == 0 then
  boatInfo[2] = 480
  boatInfo[3] = 272
  EndGame()
 end
end

function MyRandom(small,big)
 return math.random(small,big)
end

x0 = 240
y0 = 200
i=0
Form1_Load()
Form1_Paint()

repeat
pad = Controls.read()
dx = pad:analogX()
if math.abs(dx) > 32 then
 x0 = x0 + dx / 24
 if x0 < 0 then
  x0 = 0
 elseif x0 > 479 then
  x0 = 479
 end
end
dy = pad:analogY()
if math.abs(dy) > 32 then
 y0 = y0 + dy / 24
 if y0 < 0 then
  y0 = 0
 elseif y0 > 271 then
  y0 = 271
 end
end
if pad:cross() and pad~=oldPad then
 Form1_Click()
end
if i==1 then
 Timer1_Tick()
 Timer2_Tick()
end
if gameOver == 0 then
 i=math.mod(i+1,2)
end
oldPad=pad
until pad:start()
Form1_Disposed()
